Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision c5f8363fcfbc3bdd15beb961f43e1bea9d0c3389)
+++ src/builder.cpp	(revision 85bc8ed4237242b37b2c65bd7f08530fce9700cf)
@@ -1369,5 +77,6 @@
  * \return exit code (0 - successful, all else - something's wrong)
  */
-static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode, config& configuration, char *&ConfigFileName)
+static int ParseCommandLineOptions(int argc, char **argv, MoleculeListClass *&molecules, periodentafel *&periode,\
+                                   config& configuration, char *&ConfigFileName, menu *main_menu)
 {
   Vector x,y,z,n;  // coordinates for absolute point in cell volume
@@ -2170,5 +879,5 @@
     } while (argptr < argc);
     if (SaveFlag)
-      SaveConfig(ConfigFileName, &configuration, periode, molecules);
+      main_menu->SaveConfig(ConfigFileName, &configuration, periode, molecules);
   } else {  // no arguments, hence scan the elements db
     if (periode->LoadPeriodentafel(configuration.databasepath))
@@ -2185,132 +894,62 @@
 int main(int argc, char **argv)
 {
-  periodentafel *periode = new periodentafel; // and a period table of all elements
-  MoleculeListClass *molecules = new MoleculeListClass;  // list of all molecules
-  molecule *mol = NULL;
-  config *configuration = new config;
-  char choice;  // menu choice char
-  Vector x,y,z,n;  // coordinates for absolute point in cell volume
-  ifstream test;
-  ofstream output;
-  string line;
-  char *ConfigFileName = NULL;
-  int j;
-
-  setVerbosity(0);
-
-  // =========================== PARSE COMMAND LINE OPTIONS ====================================
-  j = ParseCommandLineOptions(argc, argv, molecules, periode, *configuration, ConfigFileName);
-  switch(j) {
-    case 255:  // something went wrong
-    case 2:  // just for -f option
-    case 1:  // just for -v and -h options
-      delete(molecules); // also free's all molecules contained
-      delete(periode);
-      delete(configuration);
-      Log() << Verbose(0) <<  "Maximum of allocated memory: "
-        << MemoryUsageObserver::getInstance()->getMaximumUsedMemory() << endl;
-      Log() << Verbose(0) <<  "Remaining non-freed memory: "
-        << MemoryUsageObserver::getInstance()->getUsedMemorySize() << endl;
-      MemoryUsageObserver::getInstance()->purgeInstance();
-      logger::purgeInstance();
-      errorLogger::purgeInstance();
-     return (j == 1 ? 0 : j);
-    default:
-      break;
-  }
-
-  // General stuff
-  if (molecules->ListOfMolecules.size() == 0) {
-    mol = new molecule(periode);
-    if (mol->cell_size[0] == 0.) {
-      Log() << Verbose(0) << "enter lower tridiagonal form of basis matrix" << endl << endl;
-      for (int i=0;i<6;i++) {
-        Log() << Verbose(1) << "Cell size" << i << ": ";
-        cin >> mol->cell_size[i];
-      }
+  periodentafel *periode = new periodentafel;
+    MoleculeListClass *molecules = new MoleculeListClass;
+    molecule *mol = NULL;
+    config *configuration = new config;
+    Vector x, y, z, n;
+    ifstream test;
+    ofstream output;
+    string line;
+    char *ConfigFileName = NULL;
+    int j;
+    menu *main_menu;
+    main_menu = new menu;
+    setVerbosity(0);
+    /* main menu is needed to call actions inside the menu */
+    /* structure of ParseCommandLineOptions will be refactored later */
+    j = ParseCommandLineOptions(argc, argv, molecules, periode, *configuration, ConfigFileName,main_menu);
+    switch (j){
+        case 255:
+        case 2:
+        case 1:
+            delete (molecules);
+            delete (periode);
+            delete (configuration);
+            Log() << Verbose(0) << "Maximum of allocated memory: " << MemoryUsageObserver::getInstance()->getMaximumUsedMemory() << endl;
+            Log() << Verbose(0) << "Remaining non-freed memory: " << MemoryUsageObserver::getInstance()->getUsedMemorySize() << endl;
+            MemoryUsageObserver::getInstance()->purgeInstance();
+            logger::purgeInstance();
+            errorLogger::purgeInstance();
+            return (j == 1 ? 0 : j);
+        default:
+            break;
     }
-    mol->ActiveFlag = true;
-    molecules->insert(mol);
-  }
-
-  // =========================== START INTERACTIVE SESSION ====================================
-
-  // now the main construction loop
-  Log() << Verbose(0) << endl << "Now comes the real construction..." << endl;
-  do {
-    Log() << Verbose(0) << endl << endl;
-    Log() << Verbose(0) << "============Molecule list=======================" << endl;
-    molecules->Enumerate((ofstream *)&cout);
-    Log() << Verbose(0) << "============Menu===============================" << endl;
-    Log() << Verbose(0) << "a - set molecule (in)active" << endl;
-    Log() << Verbose(0) << "e - edit molecules (load, parse, save)" << endl;
-    Log() << Verbose(0) << "g - globally manipulate atoms in molecule" << endl;
-    Log() << Verbose(0) << "M - Merge molecules" << endl;
-    Log() << Verbose(0) << "m - manipulate atoms" << endl;
-    Log() << Verbose(0) << "-----------------------------------------------" << endl;
-    Log() << Verbose(0) << "c - edit the current configuration" << endl;
-    Log() << Verbose(0) << "-----------------------------------------------" << endl;
-    Log() << Verbose(0) << "s - save current setup to config file" << endl;
-    Log() << Verbose(0) << "T - call the current test routine" << endl;
-    Log() << Verbose(0) << "q - quit" << endl;
-    Log() << Verbose(0) << "===============================================" << endl;
-    Log() << Verbose(0) << "Input: ";
-    cin >> choice;
-
-    switch (choice) {
-      case 'a':  // (in)activate molecule
-        {
-          Log() << Verbose(0) << "Enter index of molecule: ";
-          cin >> j;
-          for(MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++)
-            if ((*ListRunner)->IndexNr == j)
-              (*ListRunner)->ActiveFlag = !(*ListRunner)->ActiveFlag;
+    if(molecules->ListOfMolecules.size() == 0){
+        mol = new molecule(periode);
+        if(mol->cell_size[0] == 0.){
+            Log() << Verbose(0) << "enter lower tridiagonal form of basis matrix" << endl << endl;
+            for(int i = 0;i < 6;i++){
+                Log() << Verbose(1) << "Cell size" << i << ": ";
+                cin >> mol->cell_size[i];
+            }
         }
-        break;
-
-      case 'c': // edit each field of the configuration
-       configuration->Edit();
-       break;
-
-      case 'e': // create molecule
-        EditMolecules(periode, molecules);
-        break;
-
-      case 'g': // manipulate molecules
-        ManipulateMolecules(periode, molecules, configuration);
-        break;
-
-      case 'M':  // merge molecules
-        MergeMolecules(periode, molecules);
-        break;
-
-      case 'm': // manipulate atoms
-        ManipulateAtoms(periode, molecules, configuration);
-        break;
-
-      case 'q': // quit
-        break;
-
-      case 's': // save to config file
-        SaveConfig(ConfigFileName, configuration, periode, molecules);
-        break;
-
-      case 'T':
-        testroutine(molecules);
-        break;
-
-      default:
-        break;
-    };
-  } while (choice != 'q');
-
-  // save element data base
-  if (periode->StorePeriodentafel(configuration->databasepath)) //ElementsFileName
-    Log() << Verbose(0) << "Saving of elements.db successful." << endl;
-  else
-    Log() << Verbose(0) << "Saving of elements.db failed." << endl;
-
-  delete(molecules); // also free's all molecules contained
-  delete(periode);
+
+        mol->ActiveFlag = true;
+        molecules->insert(mol);
+    }
+
+
+
+    main_menu->perform(molecules, configuration, periode, ConfigFileName);
+
+    if(periode->StorePeriodentafel(configuration->databasepath))
+        Log() << Verbose(0) << "Saving of elements.db successful." << endl;
+
+    else
+        Log() << Verbose(0) << "Saving of elements.db failed." << endl;
+
+    delete (molecules);
+    delete(periode);
   delete(configuration);
 
